require 'test/unit'

if defined? YARV_PATCHED
require 'yarvutil'

class YarvTestBase < Test::Unit::TestCase

  def remove_const sym
    Object.module_eval{
      remove_const sym
    }
  end

  def remove_method sym
    Object.module_eval{
      undef sym
    }
  end
  
  def ae str
    # puts str
    # puts YARVUtil.parse(str, $0, 0).disasm

    ruby = YARVUtil.eval_in_wrap(str)
    yield if block_given?

    yarv = YARVUtil.eval(str)
    yield if block_given?

    assert_equal(ruby, yarv)
  end
  
  def test_
  end

end

else

class YarvTestBase < Test::Unit::TestCase
  def initialize *args
    super
    
    @yarv = ARGV.each{|e| break $1 if /^yarv=(.+)/ =~ ARGV[0]} or raise
    @ruby = ARGV.each{|e| break $1 if /^ruby=(.+)/ =~ ARGV[1]} or raise
  end

  def remove_const sym
    Object.module_eval{
      remove_const sym
    }
  end

  def remove_method sym
    Object.module_eval{
      undef sym
    }
  end

  def exec exec_file, program
    r = ''
    IO.popen("#{exec_file}", 'r+'){|io|
      #
      io.write program
      io.close_write
      begin
        while line = io.gets
          r << line
        end
      rescue => e
      end
    }
    r
  end
  
  def ae str
    str = %{
      p eval(%q{
        #{str}
      })
    }

    ruby = exec(@ruby, str)
    yarv = exec(@yarv, str)

    if $DEBUG #|| true
      puts "yarv (#@yarv): #{yarv}"
      puts "ruby (#@ruby): #{ruby}"
    end

    assert_equal(ruby, yarv)
  end
  
  def test_
  end
end

end
